/*
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2006 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   ### File Specific:
   main-programmer: Benjamin Grauer
   co-programmer: ...
*/

#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_LOADING

#include "resource.h"


namespace Loading
{
  /**
   * @brief Initializes a shared Resource
   */
  Resource::SharedResource::SharedResource()
  {
    this->referenceCount = 1;
    this->type = CL_NULL;
    this->prio = RP_NO;
  }


  /**
   * @brief standard constructor
  */
  Resource::Resource (const std::string& fileName, ResourcePriority prio)
  {
    this->setClassID(CL_RESOURCE, "Resource");
    this->resource = NULL;

  }

  /**
   * @brief standard deconstructor
   */
  Resource::~Resource ()
  {}


  bool Resource::load(std::string& fileName, ResourcePriority prio,
                      const MultiType& param0, const MultiType& param1, const MultiType& param2)
  {}


  bool Resource::cache(std::string& fileName, ResourcePriority prio,
                       const MultiType& param0, const MultiType& param1,  const MultiType& param2)
  {}


  /**
   * @brief reloads the resource.
   */
  bool Resource::reload()
  {}

  bool Resource::unload()
  {}

  // checks if a resource was already loaded.
  bool Resource::isLoaded(std::string& fileName,
                          const MultiType& param0, const MultiType& param1, const MultiType& param2)
  {}

  // raises the priority can only be raised
  void Resource::raisePriority(ResourcePriority prio)
  {}


  bool Resource::reloadResourcesByType(ClassID ResourceType)
  {}

  bool Resource::reloadAllResources()
  {}

  bool Resource::unloadResourcesByType(ResourcePriority prio)
  {}


  bool Resource::unloadAllResources()
  {}

  void Resource::debug()
  {}




  const Resource::SharedResource* Resource::findResource(std::string& fileName,
      const MultiType& param0, const MultiType& param1, const MultiType& param2)
  {}

}
